Attribute VB_Name = "Module1"
Type POINTAPI
        x As Long
        y As Long
End Type

Type STARTUPINFO
        cb As Long
        lpReserved As String
        lpDesktop As String
        lpTitle As String
        dwX As Long
        dwY As Long
        dwXSize As Long
        dwYSize As Long
        dwXCountChars As Long
        dwYCountChars As Long
        dwFillAttribute As Long
        dwFlags As Long
        wShowWindow As Integer
        cbReserved2 As Integer
        lpReserved2 As Byte
        hStdInput As Long
        hStdOutput As Long
        hStdError As Long
End Type

Type PROCESSENTRY32
  Size As Long
  Usage As Long
  ProcessID As Long
  DefaultHeapID As Long
  ModuleID As Long
  Threads As Long
  ParentProcessID As Long
  PriClassBase As Long
  flags As Long
  ExeFile As String * 260
End Type

Type LV_ITEM
  mask As Long
  iItem As Long
  hSubItem As Long
  state As Long
  stateMask As Long
  Text As String
  TextMax As Long
  Image As Long
  lParam As Long
End Type

Type LV_Column
  mask As Long
  fmt As Long
  cx As Long
  pszText As String
  cchTextMax As Long
  iSubItem As Long
End Type

Type NMHDR
  hwndFrom As Long
  idFrom As Long
  code As Long
End Type

Type NM_LISTVIEW
  hdr As NMHDR
  iItem As Long
  iSubItem As Long
  uNewState As Long
  uOldState As Long
  uChanged As Long
  ptAction As POINTAPI
  lParam As Long
End Type

Private Type MODULEENTRY32
  dwSize As Long
  th32ModuleID As Long
  th32ProcessID As Long
  GlblcntUsage As Long
  ProccntUsage As Long
  modBaseAddr As Long
  modBaseSize As Long
  hModule As Long
  szModule As String * 256
  szExePath As String * 260
End Type

Public Const WS_VISIBLE = &H10000000
Public Const WS_TABSTOP = &H10000
Public Const WS_CHILD = &H40000000
Public Const WM_NOTIFY = &H4E
Public Const LVN_ITEMCHANGING = -100
Public Const LVN_ITEMCHANGED = -101
Public Const LVN_INSERTITEM = -102
Public Const LVN_DELETEITEM = -103
Public Const LVN_DELETEALLITEMS = -104
Public Const LVN_BEGINLABELEDITA = -105
Public Const LVN_BEGINLABELEDITW = -175
Public Const LVN_ENDLABELEDITA = -106
Public Const LVN_ENDLABELEDITW = -176
Public Const LVN_COLUMNCLICK = -108
Public Const LVN_BEGINDRAG = -109
Public Const LVN_BEGINRDRAG = -111
Public Const WM_COMMAND = &H111
Public Const IDLE_PRIORITY_CLASS = &H40
Public Const NORMAL_PRIORITY_CLASS = &H20
Public Const HIGH_PRIORITY_CLASS = &H80
Public Const REALTIME_PRIORITY_CLASS = &H100
Public Const NM_OUTOFMEMORY = -1
Public Const NM_CLICK = -2           ' uses NMCLICK struct
Public Const NM_DBLCLK = -3
Public Const NM_RETURN = -4
Public Const NM_RCLICK = -5          ' uses NMCLICK struct
Public Const NM_RDBLCLK = -6
Public Const NM_SETFOCUS = -7
Public Const NM_KILLFOCUS = -8
Public Const NM_CUSTOMDRAW = -12
Public Const NM_HOVER = -13
Public Const NM_NCHITTEST = -14      ' uses NMMOUSE struct
Public Const NM_KEYDOWN = -15        ' uses NMKEY struct
Public Const NM_RELEASEDCAPTURE = -16
Public Const NM_SETCURSOR = -17      ' uses NMMOUSE struct
Public Const NM_CHAR = -18           ' uses NMCHAR struct


Declare Function CreateToolhelpSnapshot Lib "kernel32" Alias "CreateToolhelp32Snapshot" (ByVal lFlags As Long, ByVal lProcessID As Long) As Long
Declare Function ProcessFirst Lib "kernel32" Alias "Process32First" (ByVal hSnapshot As Long, uProcess As PROCESSENTRY32) As Long
Declare Function ProcessNext Lib "kernel32" Alias "Process32Next" (ByVal hSnapshot As Long, uProcess As PROCESSENTRY32) As Long
Declare Function CloseHandle Lib "kernel32" (ByVal hObject As Long) As Long
Declare Function CreateWindowEx Lib "user32" Alias "CreateWindowExA" (ByVal dwExStyle As Long, ByVal lpClassName As String, ByVal lpWindowName As String, ByVal dwStyle As Long, ByVal x As Long, ByVal y As Long, ByVal nWidth As Long, ByVal nHeight As Long, ByVal HWndParent As Long, ByVal hMenu As Long, ByVal hInstance As Long, lpParam As Any) As Long
Declare Sub InitCommonControls Lib "comctl32" ()
Declare Function DestroyWindow Lib "user32" (ByVal hwnd As Long) As Long
Declare Function ShowWindow Lib "user32" (ByVal hwnd As Long, ByVal nCmdShow As Long) As Long
Declare Function SendMessage Lib "user32" Alias "SendMessageA" (ByVal hwnd As Long, ByVal wMsg As Long, ByVal wParam As Long, lParam As Any) As Long
Declare Function LoadIcon Lib "user32" Alias "LoadIconA" (ByVal hInstance As Long, ByVal lpIconName As Long) As Long
Declare Function ImageList_Create Lib "comctl32" (ByVal cx As Long, ByVal cy As Long, ByVal flags As Long, ByVal cInitial As Long, ByVal cGrow As Long) As Long
Declare Function ImageList_Destroy Lib "comctl32" (ByVal himl As Long) As Long
Declare Function ImageList_ReplaceIcon Lib "comctl32" (ByVal himl As Long, ByVal i As Long, ByVal hIcon As Long) As Long
Declare Function CallWindowProcA Lib "user32" (ByVal lpPrevWndFunc As Long, ByVal lngHandle As Long, ByVal lngMsg As Long, ByVal lngFirstParam As Long, ByVal lngLastParam As Long) As Long
Declare Function SetWindowLongA Lib "user32" (ByVal lngHandle As Long, ByVal nIndex As Long, ByVal dwNewLong As Long) As Long
Declare Sub CopyMemory Lib "kernel32" Alias "RtlMoveMemory" (pDst As Any, ByVal pSrc As Long, ByVal ByteLen As Long)
Declare Function GetLastError Lib "kernel32" () As Long
Declare Sub ReleaseCapture Lib "user32" ()
Declare Function Module32First Lib "kernel32" (ByVal hSnapshot As Long, uProcess As MODULEENTRY32) As Long
Declare Function Module32Next Lib "kernel32" (ByVal hSnapshot As Long, uProcess As MODULEENTRY32) As Long
Declare Function DestroyIcon Lib "user32" (ByVal hIcon As Long) As Long
Declare Function ImageList_Remove Lib "comctl32" (ByVal himl As Long, ByVal pi As Long) As Long
Declare Function OpenProcess Lib "Kernel32.dll" (ByVal dwDesiredAccessas As Long, ByVal bInheritHandle As Long, ByVal dwProcId As Long) As Long
Declare Function TerminateProcess Lib "kernel32" (ByVal hProcess As Long, ByVal uExitCode As Long) As Long
Declare Sub Sleep Lib "kernel32" (ByVal dwMilliseconds As Long)
Declare Function GetFileVersionInfo Lib "version.dll" Alias "GetFileVersionInfoA" (ByVal lptstrFilename As String, ByVal dwHandle As Long, ByVal dwLen As Long, lpData As Byte) As Long
Declare Function GetFileVersionInfoSize Lib "version.dll" Alias "GetFileVersionInfoSizeA" (ByVal lptstrFilename As String, lpdwHandle As Long) As Long
Declare Function VerQueryValue Lib "version.dll" Alias "VerQueryValueA" (pBlock As Byte, ByVal lpSubBlock As String, ByVal lplpBuffer As Long, puLen As Long) As Long
Declare Function FormatMessage Lib "kernel32" Alias "FormatMessageA" (ByVal dwFlags As Long, lpSource As Any, ByVal dwMessageId As Long, ByVal dwLanguageId As Long, ByVal lpBuffer As String, ByVal nSize As Long, Arguments As Long) As Long
Declare Function GetPriorityClass Lib "kernel32" (ByVal hProcess As Long) As Long
Declare Function ExtractIconEx Lib "shell32.dll" Alias "ExtractIconExA" (ByVal lpszFile As String, ByVal nIconIndex As Long, phiconLarge As Long, phiconSmall As Long, ByVal nIcons As Long) As Long

Public NM As NM_LISTVIEW, ProcName() As String
Public hList1 As Long, hImList1 As Long, PID As Long, hIcon As Long, hList As Long
Public hSnap As Long, ret As Long, Process() As PROCESSENTRY32
Public Pr As PROCESSENTRY32, hSnap1 As Long, Module As MODULEENTRY32
Public lItem As LV_ITEM, hImList As Long, Col As LV_Column, lngOldProc As Long

Public Sub SetProc(ByVal lngHandle As Long)
lngOldProc = SetWindowLongA(lngHandle, -4, AddressOf WinProc)
End Sub

Private Function WinProc(ByVal lngHandle As Long, ByVal Msg As Long, ByVal wParam As Long, ByVal lParam As Long) As Long
Dim j As Long, n As Long
If Msg = WM_NOTIFY Then
  CopyMemory NM, lParam, 44
  If NM.hdr.code = LVN_ITEMCHANGED Then
    If NM.hdr.hwndFrom = hList Then
      PID = NM.iItem
      j = 0
      Module.dwSize = Len(Module)
      hSnap1 = CreateToolhelpSnapshot(8, Process(PID).ProcessID)
      ret = Module32First(hSnap1, Module)
      Call ClearListView(hList1)
      Call ImageList_Remove(hImList1, -1)
      Call ImageList_ReplaceIcon(hImList1, -1, LoadIcon(0, 32512))
      Call ExtractIconEx("Shell32.dll", -154, 0, hIcon, 1)
      Call ImageList_ReplaceIcon(hImList1, -1, hIcon)
      Do While ret
        lItem.mask = 1 Or 2
        lItem.hSubItem = 0
        lItem.iItem = j
        lItem.Text = Left$(Module.szModule, InStr(Module.szModule, Chr$(0)) - 1)
        Call ExtractIconEx(Module.szExePath, 0, 0, hIcon, 1)
        If hIcon = 0 Then
          If Right$(lItem.Text, 3) = "EXE" Then
            lItem.Image = 0
          Else
            lItem.Image = 1
          End If
        Else
          lItem.Image = ImageList_ReplaceIcon(hImList1, -1, hIcon)
        End If
        Call ListView_InsertItem(hList1, lItem)
        Call DestroyIcon(hIcon)
        lItem.mask = 1
        lItem.hSubItem = 1
        lItem.iItem = j
        n = 1
        lItem.Text = Left$(Module.szExePath, InStr(Module.szExePath, lItem.Text) - 2)
        Call ListView_SetItem(hList1, lItem)
        ret = Module32Next(hSnap1, Module)
        j = j + 1
      Loop
      Form1.Label1.Caption = ProcName(PID)
    End If
  End If
  If NM.hdr.code = LVN_COLUMNCLICK Then
    
  End If
  If NM.hdr.code = NM_RCLICK And NM.hdr.hwndFrom = hList And NM.iItem <> -1 Then
    Form1.PopupMenu Form1.Popup, 2
  End If
End If

WinProc = CallWindowProcA(lngOldProc, lngHandle, Msg, wParam, lParam)
End Function

Function GetVersionInfo(ByVal pFileName As String) As String
Dim s() As Byte, l As Long, s1 As String
l = GetFileVersionInfoSize(pFileName, ByVal 0) + 1
If l > 1 Then
ReDim s(l)
Call GetFileVersionInfo(pFileName, ByVal 0, l, s(0))
For l = 0 To UBound(s)
    s1 = s1 & Chr$(s(l))
Next

l = InStr(s1, "CompanyName")
If l > 0 Then
  l = InStr(l + 1, s1, Chr$(0))
GetVersionInfo = ": " & Mid$(s1, l + 1, InStr(l + 1, s1, vbNullChar) - l - 1)
End If

l = InStr(s1, "FileDescription")
If l > 0 Then
  l = InStr(l + 1, s1, Chr$(0))
GetVersionInfo = GetVersionInfo & vbCrLf & ": " & Mid$(s1, l + 1, InStr(l + 1, s1, vbNullChar) - l - 1)
End If

l = InStr(s1, "FileVersion")
If l > 0 Then
  l = InStr(l + 1, s1, Chr$(0))
GetVersionInfo = GetVersionInfo & vbCrLf & " : " & Mid$(s1, l + 1, InStr(l + 1, s1, vbNullChar) - l - 1)
End If

l = InStr(s1, "InternalName")
If l > 0 Then
  l = InStr(l + 1, s1, Chr$(0))
GetVersionInfo = GetVersionInfo & vbCrLf & " : " & Mid$(s1, l + 4, InStr(l + 5, s1, vbNullChar) - l - 4)
End If

l = InStr(s1, "Comments")
If l > 0 Then
  l = InStr(l + 1, s1, Chr$(0))
GetVersionInfo = GetVersionInfo & vbCrLf & ": " & Mid$(s1, l + 4, InStr(l + 5, s1, vbNullChar) - l - 4)
End If

l = InStr(s1, "LegalCopyright")
If l > 0 Then
  l = InStr(l + 1, s1, Chr$(0))
GetVersionInfo = GetVersionInfo & vbCrLf & " : " & Mid$(s1, l + 2, InStr(l + 2, s1, vbNullChar) - l - 2)
End If

l = InStr(s1, "LegalTrademarks")
If l > 0 Then
  l = InStr(l + 1, s1, Chr$(0))
GetVersionInfo = GetVersionInfo & vbCrLf & " : " & Mid$(s1, l + 1, InStr(l + 1, s1, vbNullChar) - l - 1)
End If

l = InStr(s1, "OriginalFilename")
If l > 0 Then
  l = InStr(l + 1, s1, Chr$(0))
GetVersionInfo = GetVersionInfo & vbCrLf & " : " & Mid$(s1, l + 4, InStr(l + 5, s1, vbNullChar) - l - 4)
End If

l = InStr(s1, "SpecialBuild")
If l > 0 Then
  l = InStr(l + 1, s1, Chr$(0))
GetVersionInfo = GetVersionInfo & vbCrLf & " : " & Mid$(s1, l + 4, InStr(l + 5, s1, vbNullChar) - l - 4)
End If

l = InStr(s1, "PrivateBuild")
If l > 0 Then
  l = InStr(l + 1, s1, Chr$(0))
GetVersionInfo = GetVersionInfo & vbCrLf & ": " & Mid$(s1, l + 4, InStr(l + 5, s1, vbNullChar) - l - 4)
End If

l = InStr(s1, "ProductName")
If l > 0 Then
  l = InStr(l + 1, s1, Chr$(0))
GetVersionInfo = GetVersionInfo & vbCrLf & " : " & Mid$(s1, l + 1, InStr(l + 1, s1, vbNullChar) - l - 1)
End If

l = InStr(s1, "ProductVersion")
If l > 0 Then
  l = InStr(l + 1, s1, Chr$(0))
GetVersionInfo = GetVersionInfo & vbCrLf & " : " & Mid$(s1, l + 2, InStr(l + 2, s1, vbNullChar) - l - 2)
End If
Else
 GetVersionInfo = "    "
End If
End Function

Function ListView_InsertItem(ByVal phListView As Long, pListItem As LV_ITEM) As Long
ListView_InsertItem = SendMessage(phListView, &H1007, ByVal 0, pListItem)
End Function

Function CreateListView(ByVal HWndParent As Long, ByVal pHInstance As Long, ByVal pX As Long, ByVal pY As Long, ByVal pWidth As Long, ByVal pHeight As Long, ByVal pStyle As Long) As Long
CreateListView = CreateWindowEx(&H200, "SysListView32", vbNullString, WS_CHILD Or pStyle, pX, pY, pWidth, pHeight, HWndParent, ByVal 0, pHInstance, ByVal 0)
Call ShowWindow(CreateListView, 5)
End Function

Function ClearListView(ByVal hListView As Long) As Long
ClearListView = SendMessage(hListView, &H1009, 0, 0)
End Function

Function ListView_SetImageList(ByVal phListView As Long, ByVal phImageList As Long) As Long
SetImageList = SendMessage(phListView, &H1003, 1, ByVal phImageList)
End Function

Function ListView_SetColumn(ByVal phListView As Long, pColumn As LV_Column) As Long
ListView_SetColumn = SendMessage(phListView, &H101B, ByVal pColumn.iSubItem, pColumn)
End Function

Function ListView_SetItem(ByVal phListView As Long, pListItem As LV_ITEM) As Long
ListView_SetItem = SendMessage(phListView, &H1006, ByVal 0, pListItem)
End Function
